import es
import popuplib
import cPickle
import os.path
import gamethread
import urllib2

##################################### START of Options #####################################################################################
#                                                                                                                                          #
scriptlanguage = "en"                                                # "en" = english, "de" = deutsch                                      #      
admins = ["STEAM_ID_LAN", "BOT"]                                     # Steamids, that not kicked | Steamids, die nicht gekickt werden      #
kickmessage = "Sorry, this is a noob Server, you KD is too high"     # Kick Reason | Kick Grund                                            #
kd_begrenz = 2                                                       # Maximal KD                                                          #
kd_kills = 10                                                        # Minimal Kills                                                       #
popupstart = 1                                                       # Popup with KD at Spawn, 1 = On | Popup mit KD beim Spawnen, 1 = An  #
#                                                                                                                                          #
##################################### END of Options #######################################################################################

deathlist = {}
killlist = {}

info = es.AddonInfo()
info.basename = 'KDkick'
info.name     = 'Kick Players with too high KD'
info.author   = 'popoklopsi'
info.version  = '1.0'
es.ServerVar('KDkick', info.version).makepublic()

def load():
    global file
    global admins
    global killlist
    global deathlist
    global scriptlanguage
    global kd_begrenz
    global kickmessage
    global popupstart
    file = es.getAddonPath('KDkick') + '/death.db'
    file2 = es.getAddonPath('KDkick') + '/kill.db'
    if os.path.isfile(file):
        file_players = open(file)
        deathlist = cPickle.load(file_players)
        file_players.close()
    if os.path.isfile(file2):
        file_players = open(file2)
        killlist = cPickle.load(file_players)
        file_players.close()

def player_death(ev):
     thesteamid1 = ev["es_attackersteamid"]
     thesteamid2 = ev["es_steamid"]
     if thesteamid1 != "BOT":
       if ev["es_userteam"] != ev["es_attackerteam"]:
          if killlist.has_key(thesteamid1):
             killlist[thesteamid1] = killlist.get(thesteamid1) + 1
          else:
             killlist[thesteamid1] = 1
     if thesteamid2 != "BOT":
       if ev["es_userteam"] != ev["es_attackerteam"]:
          if deathlist.has_key(thesteamid2):
             deathlist[thesteamid2] = deathlist.get(thesteamid2) + 1
          else:
             deathlist[thesteamid2] = 1

def player_spawn(ev):
    theuserid = ev["userid"]
    thesteamid = ev["es_steamid"]
    if deathlist.has_key(thesteamid):
          kills = killlist.get(thesteamid)
          deaths = deathlist.get(thesteamid)
          kd = kills/deaths
          if popupstart == 1:
             if scriptlanguage == "de":
                startpopup = popuplib.create('startpopup')
                startpopup.addline("Du hast %i Kills" % kills )
                startpopup.addline("Du hast %i Deaths" % deaths )
                startpopup.addline("Du hast eine KD von %i" % kd )
                startpopup.addline("Maximale KD ist %i beginnt mit %i Kills" % (kd_begrenz,kd_kills))
                startpopup.send(theuserid)
                gamethread.delayed(5, popuplib.unsendname, ("startpopup", theuserid))
             if scriptlanguage == "en":
                startpopup = popuplib.create('startpopup')
                startpopup.addline("You have %i Kills" % kills )
                startpopup.addline("You have %i Deaths" % deaths )
                startpopup.addline("You have a KD of %i" % kd )
                startpopup.addline("Maximal KD is %i beginning with %i Kills" % (kd_begrenz,kd_kills))
                startpopup.send(theuserid)
                gamethread.delayed(5, popuplib.unsendname, ("startpopup", theuserid))
          if kills > kd_kills:
             if kd >= kd_begrenz:
                if  thesteamid not in admins:
                    es.server.queuecmd("kickid %s %s" % (theuserid, kickmessage))

def unload():
    save_dictionary()
    save_dictionary2()

def round_start(ev):
    save_dictionary()
    save_dictionary2()

def save_dictionary():
   file_players = open(es.getAddonPath('KDkick') + '/death.db', 'wb')
   cPickle.dump(deathlist, file_players)
   file_players.close()

def save_dictionary2():
   file_players = open(es.getAddonPath('KDkick') + '/kill.db', 'wb')
   cPickle.dump(killlist, file_players)
   file_players.close()